//
//  CustomVoiceController.swift
//  NavigationUIExemple
//
//  Created by Hassine on 17/06/2020.
//  Copyright © 2020 com.mile. All rights reserved.
//

import UIKit
import MapboxSpeech
import Mapbox
import AVFoundation
import MapboxSpeech
import MapboxCoreNavigation
import MapboxDirections
import MapboxNavigation

/// MapboxVoiceController 82

//@objc public func audioPlayerDidFinishPlaying(_ player: AVAudioPlayer, successfully flag: Bool) {
//    do {
//        try unDuckAudio()
//         NotificationCenter.default.post(name:NSNotification.Name("finishAudio"),object: nil)
//        print("finishAudio")
//    } catch {
//        voiceControllerDelegate?.voiceController?(self, spokenInstructionsDidFailWith: error)
//    }
//
//}



class CustomVoiceController: MapboxVoiceController {
    
    override func audioPlayerDidFinishPlaying(_ player: AVAudioPlayer, successfully flag: Bool) {
        super.audioPlayerDidFinishPlaying(player, successfully: flag)
        NotificationCenter.default.post(name:NSNotification.Name("finishAudio"),object: nil)
    }
    
    override func didPassSpokenInstructionPoint(notification: NSNotification) {
        print(notification)
        super.didPassSpokenInstructionPoint(notification: notification)
        let routeProgress = notification.userInfo![RouteControllerNotificationUserInfoKey.routeProgressKey] as! RouteProgress
        print(routeProgress.currentLegProgress.currentStep.maneuverType)
        //        let soundForInstruction = audio(for: routeProgress.currentLegProgress.currentStep)
        let instruction = notification.userInfo![RouteControllerNotificationUserInfoKey.spokenInstructionKey] as! SpokenInstruction
        //        play(instruction: instruction, data: soundForInstruction)
        
        if routeProgress.currentLegProgress.currentStep.maneuverType == .depart
        {
            if  let steps = routeProgress.currentLegProgress.currentStep.instructionsSpokenAlongStep
            {
                if steps.count > 1
                {
                    //  play(instruction: instruction, data: soundForInstruction)
                }
            }
        }
        
        
    }
    
    override func speak(_ instruction: SpokenInstruction) {
        super.speak(instruction)
    }
    
    func initNotification()
    {
        NotificationCenter.default.addObserver(self,selector: #selector(playerDidFinishPlaying),name: NSNotification.Name ("finishAudio"),object: nil)
    }
    
    func playDirectionnal(_ data: Data) -> Void {
        guard !NavigationSettings.shared.voiceMuted else { return }
        if (  PlayerManager.shared.speechSynthesizer.isSpeaking )
        {
            PlayerManager.shared.speechSynthesizer.pauseSpeaking(at: AVSpeechBoundary.immediate)
        }
        super.play(data)
    }
    
    func stopPlayer() -> Void
    {
        self.audioPlayer?.stop()
    }
    
    
    override func play(_ data: Data) {
        if (MyNavigationView.mutedZone == false)
        {
            if (  PlayerManager.shared.speechSynthesizer.isSpeaking )
            {
                PlayerManager.shared.speechSynthesizer.pauseSpeaking(at: AVSpeechBoundary.word)
                //    PlayerManager.shared.pausePlayerDirectional()
            }
            super.play(data)
        }
        else
        {
            print("muted zone")
        }
    }
    
    
    @objc func playerDidFinishPlaying() {
        if let player = self.audioPlayer
        {
            if !player.isPlaying
            {
                if PlayerManager.shared.speechSynthesizer.isPaused{
                    PlayerManager.shared.speechSynthesizer.continueSpeaking()
                }
            }
        }
    }
}


